unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Win.ComObj;

Const
    VendorId = 4660;
    ProductId = 1;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Type deviceInfoType = record
   DevicePath      : String;
   DeviceSerial    : String;
   DeviceType      : String;
   DeviceModel     : String;
   FirmWareVersion : String;
   numPorts        : Byte;
end;

Var
     ceClass : Variant;
     devInfo : deviceInfoType;
     s : String;


Procedure List_Connected_Devices();
var
    i : Byte;

    devPath   : Variant;
    devSerial : Variant;
    devType   : Variant;
    devModel  : Variant;
    fwVersion : Variant;
    numPorts  : Variant;

begin
    if ceClass.numConnectedDevices > 0
       then begin
          for i := 0 to ceClass.numConnectedDevices -1
            do begin
                Form1.Memo1.Text := 'CONNECTED DEVICES : ' + #13#10;
                if ceClass.getDeviceInfo(i ,devPath, devSerial, devType, devModel, fwVersion, numPorts) = 1 then begin
                     Form1.Memo1.Text := Form1.Memo1.Text +
                                      '#' + intToStr(i) +
                                      ': Device Serial : ' + VarToStr(devSerial) +
                                      ', Device Type : '  + VarToStr(devType) +
                                      ', Device Model : '  + VarToStr(devModel)+
                                      ', Input Ports : '  + VarToStr(numPorts);
                end;
                Form1.Memo1.Text := Form1.Memo1.Text + #13#10
            end;
      end
      else begin
          Form1.Memo1.Text := 'NO DEVICES CONNECTED ' + #13#10;
      end;
end;

procedure DeviceArrival(); stdcall;
begin
  str(ceClass.numConnectedDevices:0:0, s);
  Form1.Label1.Caption := 'Connected Devices : ' + s + ' of 4 (New Device(s) Attached)';
  List_Connected_Devices();
end;

procedure DeviceRemove(); stdcall;
begin
  str(ceClass.numConnectedDevices:0:0, s);
  Form1.Label1.Caption := 'Connected Devices : ' + s + ' of 4  (Device(s) Removed)';
  List_Connected_Devices();
end;

procedure LiveEventReceived(DeviceSerial:PAnsiChar;
                            Port:Char;
                            Event:PAnsiChar); stdcall;
begin
  //Form1.Label2.Caption := 'Live Event : ' + #34 + StrPas(Event) + #34 +'   Detected on Port : ' + Port + ' of Device : ' + strPas(DeviceSerial);
  Form1.Memo1.Text := Form1.Memo1.Text + 'Live Event : ' + #34 + StrPas(Event) + #34 +'   Detected on Port : ' + Port + ' of Device : ' + strPas(DeviceSerial) + #13#10
end;

procedure NewCallReceived(DeviceSerial:PAnsiChar;
                          Caller:PAnsiChar;
                          Callee:PAnsiChar;
                          CallId:PAnsiChar;
                          Port:Char;
                          Year:PAnsiChar;
                          Month:PAnsiChar;
                          Day:PAnsiChar;
                          Hour:PAnsiChar;
                          Minute:PAnsiChar); stdcall;
begin
  Form1.Memo1.Text := Form1.Memo1.Text + 'New Call : Caller : ' + StrPas(Caller)+ ', Calee : ' + StrPas(Callee)+ ', Dt/Tm : ' + StrPas(Year)+'-'+StrPas(Month)+'-'+StrPas(Day)+' '+StrPas(Hour)+':'+StrPas(Minute)+#13#10;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ceClass := CreateOleObject('CEHIDLibrary.CidEasyHIDLibrary');
  ceClass.ConstructModels(VendorId, ProductId);
  ceClass.enableCheckDigitControl := TRUE;
  ceClass.followLineEvents := TRUE;

  str(ceClass.numConnectedDevices:0:0, s);
  Form1.Label1.Caption := 'Connected Devices : ' + s + ' of 4 (Max 4 devices can be connected)';
    Form1.Memo1.Text := '';

  ceClass.SetOleDelegate(ceClass.oleDelegate_onDeviceArrival, Long(@DeviceArrival));
  ceClass.SetOleDelegate(ceClass.oleDelegate_onDeviceRemove,  Long(@DeviceRemove));
  ceClass.SetOleDelegate(ceClass.oleDelegate_onLineEvent,     Long(@LiveEventReceived));

  ceClass.SetOleDelegate(ceClass.oleDelegate_onNewCall_v2,    Long(@NewCallReceived));
end;

end.
