﻿Imports System.ComponentModel
Imports System.Text
Imports System.Windows.Forms
Imports CEHIDLibrary
Imports System.Diagnostics
Imports System.Runtime.InteropServices
Imports System.Threading
Imports Microsoft.Win32

Namespace CidSample
    Partial Public Class Form1
        Inherits Form

        Delegate Sub SetTextCallback()
        Private tVendorId As Int32 = 4660
        Private tProductId As Int32 = 1
        Private CE_Library As CEHIDLibrary.CidEasyHIDLibrary = New CEHIDLibrary.CidEasyHIDLibrary()
        Private theCallerId As String

        Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            InitializeComponent()

            CE_Library.ConstructModels(tVendorId, tProductId)

            CE_Library.enableCheckDigitControl = True
            CE_Library.followLineEvents = True

            AddHandler CE_Library.onNewCall_v2, AddressOf NewCallHandler
            AddHandler CE_Library.onDeviceArrival, AddressOf DeviceArrival
            AddHandler CE_Library.onDeviceRemove, AddressOf DeviceRemove
            AddHandler CE_Library.onLineEvent, AddressOf LineEvent
        End Sub

        Public Sub NewCallHandler(ByVal DeviceSerial As String, ByVal Caller As String, ByVal Callee As String, ByVal CallId As String, ByVal Port As String, ByVal Year As String, ByVal Month As String, ByVal Day As String, ByVal Hour As String, ByVal Minute As String)
            Debug.Print("New Call Received on Device : " + DeviceSerial + " of Port : " + Port)
            Debug.Print("                     Caller : " + Caller)
            Debug.Print("                     Callee : " + Callee)
            Debug.Print("                     CallId : " + CallId)
            Debug.Print("                     Dt/Tm  : " + Year + "-" + Month + "-" + Day + " " + Hour + ":" + Minute)

            theCallerId = Caller
            DisplayCallerID()
        End Sub

        Public Sub LineEvent(ByVal DeviceSerial As String, ByVal Port As Char, ByVal theEvent As String)
            Debug.Print("Line Event Received : " + DeviceSerial + " " + Port + " " + theEvent)
        End Sub

        Private Sub DisplayCallerID()
            'If request comes from different thread, invoke it in user thread
            If lblCID.InvokeRequired Then
                Dim d As SetTextCallback = New SetTextCallback(AddressOf DisplayCallerID)
                Me.Invoke(d, New Object() {})
            Else
                lblCID.Text = theCallerId & vbLf & lblCID.Text
            End If
        End Sub

        Private Sub DeviceArrival()
            Debug.Print("DEVICE ARRIVAL")
            List_Connected_Devices()
        End Sub

        Private Sub DeviceRemove()
            Debug.Print("DEVICE REMOVED")
            List_Connected_Devices()
        End Sub

        Private Sub List_Connected_Devices()
            If CE_Library.numConnectedDevices > 0 Then
                Debug.Print("LIST OF CONNECTED DEVICES :")
                For i As Integer = 0 To CE_Library.numConnectedDevices - 1
                    'Debug.Print("#" & i & " : " & CE_Library.deviceInfoList(i).DeviceSerial & " " + CE_Library.deviceInfoList(i).FirmWareVersion & " " + CE_Library.deviceInfoList(i).PathName)
                    Debug.Print("#" + i + ": Serial Number : " + CE_Library.deviceInfoList(i).DeviceSerial + _
                                          ", FirmWare Version : " + CE_Library.deviceInfoList(i).FirmWareVersion + _
                                          ", Device Type : " + CE_Library.deviceInfoList(i).DeviceType + _
                                          ", Device Model :  " + CE_Library.deviceInfoList(i).DeviceModel + _
                                          ", Number of Input Ports :  " + CE_Library.deviceInfoList(i).numPorts)
                Next
                Debug.Print("")
            Else
                Debug.Print("NO DEVICECONNECTED...")
            End If

        End Sub








        Private WithEvents lblCID As System.Windows.Forms.Label

        Private Sub InitializeComponent()
            Me.lblCID = New System.Windows.Forms.Label()
            Me.SuspendLayout()
            '
            'lblCID
            '
            Me.lblCID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            Me.lblCID.Font = New System.Drawing.Font("Microsoft Sans Serif", 15.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(162, Byte))
            Me.lblCID.Location = New System.Drawing.Point(12, 22)
            Me.lblCID.Name = "lblCID"
            Me.lblCID.Size = New System.Drawing.Size(389, 212)
            Me.lblCID.TabIndex = 1
            '
            'Form1
            '
            Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
            Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
            Me.ClientSize = New System.Drawing.Size(415, 248)
            Me.Controls.Add(Me.lblCID)
            Me.Name = "Form1"
            Me.Text = "VB.NET Sample"
            Me.ResumeLayout(False)

        End Sub

    End Class
End Namespace
